/* Settings.c generated by valac 0.38.2, the Vala compiler
 * generated from Settings.vala, do not modify */

/*
 * Copyright (c) 2011-2016 Snap Developers (http://launchpad.net/snap-elementary)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */

#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>


#define SNAP_BACKEND_TYPE_SETTINGS (snap_backend_settings_get_type ())
#define SNAP_BACKEND_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SNAP_BACKEND_TYPE_SETTINGS, SnapBackendSettings))
#define SNAP_BACKEND_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SNAP_BACKEND_TYPE_SETTINGS, SnapBackendSettingsClass))
#define SNAP_BACKEND_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SNAP_BACKEND_TYPE_SETTINGS))
#define SNAP_BACKEND_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SNAP_BACKEND_TYPE_SETTINGS))
#define SNAP_BACKEND_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SNAP_BACKEND_TYPE_SETTINGS, SnapBackendSettingsClass))

typedef struct _SnapBackendSettings SnapBackendSettings;
typedef struct _SnapBackendSettingsClass SnapBackendSettingsClass;
typedef struct _SnapBackendSettingsPrivate SnapBackendSettingsPrivate;
enum  {
	SNAP_BACKEND_SETTINGS_DUMMY_PROPERTY,
	SNAP_BACKEND_SETTINGS_MODE_PROPERTY,
	SNAP_BACKEND_SETTINGS_LAST_PROPERTY
};
static GParamSpec* snap_backend_settings_properties[SNAP_BACKEND_SETTINGS_LAST_PROPERTY];
#define _g_free0(var) (var = (g_free (var), NULL))

#define SNAP_UTILS_TYPE_ACTION_TYPE (snap_utils_action_type_get_type ())
enum  {
	SNAP_BACKEND_SETTINGS_ACTION_TYPE_CHANGED_SIGNAL,
	SNAP_BACKEND_SETTINGS_LAST_SIGNAL
};
static guint snap_backend_settings_signals[SNAP_BACKEND_SETTINGS_LAST_SIGNAL] = {0};

struct _SnapBackendSettings {
	GraniteServicesSettings parent_instance;
	SnapBackendSettingsPrivate * priv;
};

struct _SnapBackendSettingsClass {
	GraniteServicesSettingsClass parent_class;
};

struct _SnapBackendSettingsPrivate {
	gchar* _mode;
};

typedef enum  {
	SNAP_UTILS_ACTION_TYPE_PHOTO,
	SNAP_UTILS_ACTION_TYPE_VIDEO
} SnapUtilsActionType;


static gpointer snap_backend_settings_parent_class = NULL;

GType snap_backend_settings_get_type (void) G_GNUC_CONST;
#define SNAP_BACKEND_SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SNAP_BACKEND_TYPE_SETTINGS, SnapBackendSettingsPrivate))
SnapBackendSettings* snap_backend_settings_new (void);
SnapBackendSettings* snap_backend_settings_construct (GType object_type);
static void snap_backend_settings_connect_signals (SnapBackendSettings* self);
GType snap_utils_action_type_get_type (void) G_GNUC_CONST;
SnapUtilsActionType snap_backend_settings_get_action_type (SnapBackendSettings* self);
const gchar* snap_backend_settings_get_mode (SnapBackendSettings* self);
void snap_backend_settings_set_action_type (SnapBackendSettings* self, SnapUtilsActionType action_type);
void snap_backend_settings_set_mode (SnapBackendSettings* self, const gchar* value);
static void __lambda4_ (SnapBackendSettings* self);
static void ___lambda4__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void snap_backend_settings_finalize (GObject * obj);
static void _vala_snap_backend_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_snap_backend_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


SnapBackendSettings* snap_backend_settings_construct (GType object_type) {
	SnapBackendSettings * self = NULL;
	self = (SnapBackendSettings*) granite_services_settings_construct (object_type, "org.pantheon.snap.settings");
	snap_backend_settings_connect_signals (self);
	return self;
}


SnapBackendSettings* snap_backend_settings_new (void) {
	return snap_backend_settings_construct (SNAP_BACKEND_TYPE_SETTINGS);
}


SnapUtilsActionType snap_backend_settings_get_action_type (SnapBackendSettings* self) {
	SnapUtilsActionType result = 0;
	SnapUtilsActionType _tmp0_ = 0;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp1_ = self->priv->_mode;
	if (g_strcmp0 (_tmp1_, "photo") == 0) {
		_tmp0_ = SNAP_UTILS_ACTION_TYPE_PHOTO;
	} else {
		_tmp0_ = SNAP_UTILS_ACTION_TYPE_VIDEO;
	}
	result = _tmp0_;
	return result;
}


void snap_backend_settings_set_action_type (SnapBackendSettings* self, SnapUtilsActionType action_type) {
	const gchar* _tmp0_ = NULL;
	SnapUtilsActionType _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = action_type;
	if (_tmp1_ == SNAP_UTILS_ACTION_TYPE_PHOTO) {
		_tmp0_ = "photo";
	} else {
		_tmp0_ = "video";
	}
	snap_backend_settings_set_mode (self, _tmp0_);
}


static void __lambda4_ (SnapBackendSettings* self) {
	SnapUtilsActionType _tmp0_;
	_tmp0_ = snap_backend_settings_get_action_type (self);
	g_signal_emit (self, snap_backend_settings_signals[SNAP_BACKEND_SETTINGS_ACTION_TYPE_CHANGED_SIGNAL], 0, _tmp0_);
}


static void ___lambda4__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda4_ ((SnapBackendSettings*) self);
}


static void snap_backend_settings_connect_signals (SnapBackendSettings* self) {
	g_return_if_fail (self != NULL);
	g_signal_connect_object ((GObject*) self, "notify::mode", (GCallback) ___lambda4__g_object_notify, self, 0);
}


const gchar* snap_backend_settings_get_mode (SnapBackendSettings* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_mode;
	result = _tmp0_;
	return result;
}


void snap_backend_settings_set_mode (SnapBackendSettings* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, snap_backend_settings_get_mode (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_mode);
		self->priv->_mode = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, snap_backend_settings_properties[SNAP_BACKEND_SETTINGS_MODE_PROPERTY]);
	}
}


static void snap_backend_settings_class_init (SnapBackendSettingsClass * klass) {
	snap_backend_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SnapBackendSettingsPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_snap_backend_settings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_snap_backend_settings_set_property;
	G_OBJECT_CLASS (klass)->finalize = snap_backend_settings_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SNAP_BACKEND_SETTINGS_MODE_PROPERTY, snap_backend_settings_properties[SNAP_BACKEND_SETTINGS_MODE_PROPERTY] = g_param_spec_string ("mode", "mode", "mode", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	snap_backend_settings_signals[SNAP_BACKEND_SETTINGS_ACTION_TYPE_CHANGED_SIGNAL] = g_signal_new ("action-type-changed", SNAP_BACKEND_TYPE_SETTINGS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, SNAP_UTILS_TYPE_ACTION_TYPE);
}


static void snap_backend_settings_instance_init (SnapBackendSettings * self) {
	self->priv = SNAP_BACKEND_SETTINGS_GET_PRIVATE (self);
}


static void snap_backend_settings_finalize (GObject * obj) {
	SnapBackendSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SNAP_BACKEND_TYPE_SETTINGS, SnapBackendSettings);
	_g_free0 (self->priv->_mode);
	G_OBJECT_CLASS (snap_backend_settings_parent_class)->finalize (obj);
}


GType snap_backend_settings_get_type (void) {
	static volatile gsize snap_backend_settings_type_id__volatile = 0;
	if (g_once_init_enter (&snap_backend_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SnapBackendSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) snap_backend_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SnapBackendSettings), 0, (GInstanceInitFunc) snap_backend_settings_instance_init, NULL };
		GType snap_backend_settings_type_id;
		snap_backend_settings_type_id = g_type_register_static (GRANITE_SERVICES_TYPE_SETTINGS, "SnapBackendSettings", &g_define_type_info, 0);
		g_once_init_leave (&snap_backend_settings_type_id__volatile, snap_backend_settings_type_id);
	}
	return snap_backend_settings_type_id__volatile;
}


static void _vala_snap_backend_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SnapBackendSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SNAP_BACKEND_TYPE_SETTINGS, SnapBackendSettings);
	switch (property_id) {
		case SNAP_BACKEND_SETTINGS_MODE_PROPERTY:
		g_value_set_string (value, snap_backend_settings_get_mode (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_snap_backend_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SnapBackendSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SNAP_BACKEND_TYPE_SETTINGS, SnapBackendSettings);
	switch (property_id) {
		case SNAP_BACKEND_SETTINGS_MODE_PROPERTY:
		snap_backend_settings_set_mode (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



