/* Utils.c generated by valac 0.38.2, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * Copyright (c) 2011-2016 Snap Developers (http://launchpad.net/snap-elementary)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>


#define SNAP_UTILS_TYPE_ACTION_TYPE (snap_utils_action_type_get_type ())
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	SNAP_UTILS_ACTION_TYPE_PHOTO,
	SNAP_UTILS_ACTION_TYPE_VIDEO
} SnapUtilsActionType;



GType snap_utils_action_type_get_type (void) G_GNUC_CONST;
gchar* snap_utils_get_new_media_filename (SnapUtilsActionType action_type);
gchar* snap_utils_build_media_filename (const gchar* filename, SnapUtilsActionType action_type);
gchar* snap_utils_get_media_directory (SnapUtilsActionType action_type);


GType snap_utils_action_type_get_type (void) {
	static volatile gsize snap_utils_action_type_type_id__volatile = 0;
	if (g_once_init_enter (&snap_utils_action_type_type_id__volatile)) {
		static const GEnumValue values[] = {{SNAP_UTILS_ACTION_TYPE_PHOTO, "SNAP_UTILS_ACTION_TYPE_PHOTO", "photo"}, {SNAP_UTILS_ACTION_TYPE_VIDEO, "SNAP_UTILS_ACTION_TYPE_VIDEO", "video"}, {0, NULL, NULL}};
		GType snap_utils_action_type_type_id;
		snap_utils_action_type_type_id = g_enum_register_static ("SnapUtilsActionType", values);
		g_once_init_leave (&snap_utils_action_type_type_id__volatile, snap_utils_action_type_type_id);
	}
	return snap_utils_action_type_type_id__volatile;
}


gchar* snap_utils_get_new_media_filename (SnapUtilsActionType action_type) {
	gchar* result = NULL;
	gchar* time = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint file_id = 0;
	gchar* next_filename = NULL;
	gchar* _tmp4_;
	const gchar* _tmp22_;
	SnapUtilsActionType _tmp23_;
	gchar* _tmp24_;
	_tmp0_ = g_date_time_new_now_local ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_format (_tmp1_, "%F%H:%M:%S");
	_tmp3_ = _tmp2_;
	_g_date_time_unref0 (_tmp1_);
	time = _tmp3_;
	file_id = 0;
	_tmp4_ = g_strdup ("");
	next_filename = _tmp4_;
	{
		gboolean _tmp5_ = FALSE;
		_tmp5_ = TRUE;
		while (TRUE) {
			gchar* _tmp12_ = NULL;
			gint _tmp13_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gint _tmp21_;
			if (!_tmp5_) {
				const gchar* _tmp6_;
				SnapUtilsActionType _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
				_tmp6_ = next_filename;
				_tmp7_ = action_type;
				_tmp8_ = snap_utils_build_media_filename (_tmp6_, _tmp7_);
				_tmp9_ = _tmp8_;
				_tmp10_ = g_file_test (_tmp9_, G_FILE_TEST_EXISTS);
				_tmp11_ = !_tmp10_;
				_g_free0 (_tmp9_);
				if (_tmp11_) {
					break;
				}
			}
			_tmp5_ = FALSE;
			_tmp13_ = file_id;
			if (_tmp13_ > 0) {
				gint _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				_tmp14_ = file_id;
				_tmp15_ = g_strdup_printf ("%i", _tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = g_strconcat ("-", _tmp16_, NULL);
				_g_free0 (_tmp12_);
				_tmp12_ = _tmp17_;
				_g_free0 (_tmp16_);
			} else {
				gchar* _tmp18_;
				_tmp18_ = g_strdup ("");
				_g_free0 (_tmp12_);
				_tmp12_ = _tmp18_;
			}
			_tmp19_ = time;
			_tmp20_ = g_strconcat (_tmp19_, _tmp12_, NULL);
			_g_free0 (next_filename);
			next_filename = _tmp20_;
			_tmp21_ = file_id;
			file_id = _tmp21_ + 1;
			_g_free0 (_tmp12_);
		}
	}
	_tmp22_ = next_filename;
	_tmp23_ = action_type;
	_tmp24_ = snap_utils_build_media_filename (_tmp22_, _tmp23_);
	result = _tmp24_;
	_g_free0 (next_filename);
	_g_free0 (time);
	return result;
}


gchar* snap_utils_build_media_filename (const gchar* filename, SnapUtilsActionType action_type) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	SnapUtilsActionType _tmp1_;
	gchar* full_filename = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* media_directory = NULL;
	SnapUtilsActionType _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean _tmp7_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	g_return_val_if_fail (filename != NULL, NULL);
	_tmp1_ = action_type;
	if (_tmp1_ == SNAP_UTILS_ACTION_TYPE_PHOTO) {
		_tmp0_ = "jpg";
	} else {
		_tmp0_ = "ogv";
	}
	_tmp2_ = filename;
	_tmp3_ = g_strdup_printf ("%s.%s", _tmp2_, _tmp0_);
	full_filename = _tmp3_;
	_tmp4_ = action_type;
	_tmp5_ = snap_utils_get_media_directory (_tmp4_);
	media_directory = _tmp5_;
	_tmp6_ = media_directory;
	_tmp7_ = g_file_test (_tmp6_, G_FILE_TEST_EXISTS);
	if (!_tmp7_) {
		const gchar* _tmp8_;
		_tmp8_ = media_directory;
		g_mkdir (_tmp8_, 0777);
	}
	_tmp9_ = media_directory;
	_tmp10_ = full_filename;
	_tmp11_ = g_build_filename (G_DIR_SEPARATOR_S, _tmp9_, _tmp10_, NULL);
	result = _tmp11_;
	_g_free0 (media_directory);
	_g_free0 (full_filename);
	return result;
}


gchar* snap_utils_get_media_directory (SnapUtilsActionType action_type) {
	gchar* result = NULL;
	GUserDirectory _tmp0_ = 0;
	SnapUtilsActionType _tmp1_;
	GUserDirectory user_dir = 0;
	gchar* media_directory = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp1_ = action_type;
	if (_tmp1_ == SNAP_UTILS_ACTION_TYPE_PHOTO) {
		_tmp0_ = G_USER_DIRECTORY_PICTURES;
	} else {
		_tmp0_ = G_USER_DIRECTORY_VIDEOS;
	}
	user_dir = _tmp0_;
	_tmp2_ = g_get_user_special_dir (user_dir);
	_tmp3_ = g_strdup (_tmp2_);
	media_directory = _tmp3_;
	_tmp4_ = g_build_path (G_DIR_SEPARATOR_S, media_directory, "Webcam", NULL);
	result = _tmp4_;
	_g_free0 (media_directory);
	return result;
}



