/* CameraView.c generated by valac 0.38.2, the Vala compiler
 * generated from CameraView.vala, do not modify */

/*
 * Copyright (c) 2011-2016 Snap Developers (http://launchpad.net/snap-elementary)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */

#include <glib.h>
#include <glib-object.h>
#include <clutter-gst/clutter-gst.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>


#define SNAP_WIDGETS_TYPE_CAMERA_VIEW (snap_widgets_camera_view_get_type ())
#define SNAP_WIDGETS_CAMERA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SNAP_WIDGETS_TYPE_CAMERA_VIEW, SnapWidgetsCameraView))
#define SNAP_WIDGETS_CAMERA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SNAP_WIDGETS_TYPE_CAMERA_VIEW, SnapWidgetsCameraViewClass))
#define SNAP_WIDGETS_IS_CAMERA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SNAP_WIDGETS_TYPE_CAMERA_VIEW))
#define SNAP_WIDGETS_IS_CAMERA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SNAP_WIDGETS_TYPE_CAMERA_VIEW))
#define SNAP_WIDGETS_CAMERA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SNAP_WIDGETS_TYPE_CAMERA_VIEW, SnapWidgetsCameraViewClass))

typedef struct _SnapWidgetsCameraView SnapWidgetsCameraView;
typedef struct _SnapWidgetsCameraViewClass SnapWidgetsCameraViewClass;
typedef struct _SnapWidgetsCameraViewPrivate SnapWidgetsCameraViewPrivate;
enum  {
	SNAP_WIDGETS_CAMERA_VIEW_DUMMY_PROPERTY,
	SNAP_WIDGETS_CAMERA_VIEW_LAST_PROPERTY
};
static GParamSpec* snap_widgets_camera_view_properties[SNAP_WIDGETS_CAMERA_VIEW_LAST_PROPERTY];
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

#define SNAP_UTILS_TYPE_ACTION_TYPE (snap_utils_action_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	SNAP_WIDGETS_CAMERA_VIEW_INITIALIZED_SIGNAL,
	SNAP_WIDGETS_CAMERA_VIEW_LAST_SIGNAL
};
static guint snap_widgets_camera_view_signals[SNAP_WIDGETS_CAMERA_VIEW_LAST_SIGNAL] = {0};

struct _SnapWidgetsCameraView {
	ClutterGstCamera parent_instance;
	SnapWidgetsCameraViewPrivate * priv;
};

struct _SnapWidgetsCameraViewClass {
	ClutterGstCameraClass parent_class;
};

typedef enum  {
	SNAP_UTILS_ACTION_TYPE_PHOTO,
	SNAP_UTILS_ACTION_TYPE_VIDEO
} SnapUtilsActionType;


static gpointer snap_widgets_camera_view_parent_class = NULL;

GType snap_widgets_camera_view_get_type (void) G_GNUC_CONST;
SnapWidgetsCameraView* snap_widgets_camera_view_new (void);
SnapWidgetsCameraView* snap_widgets_camera_view_construct (GType object_type);
static gint __lambda7_ (SnapWidgetsCameraView* self);
static void snap_widgets_camera_view_initialize_view (SnapWidgetsCameraView* self);
static gpointer ___lambda7__gthread_func (gpointer self);
gboolean snap_widgets_camera_view_take_photo (SnapWidgetsCameraView* self);
GType snap_utils_action_type_get_type (void) G_GNUC_CONST;
gchar* snap_utils_get_new_media_filename (SnapUtilsActionType action_type);
gboolean snap_widgets_camera_view_start_recording (SnapWidgetsCameraView* self);
void snap_widgets_camera_view_stop_recording (SnapWidgetsCameraView* self);
static gboolean ___lambda8_ (SnapWidgetsCameraView* self);
static gboolean ____lambda8__gsource_func (gpointer self);


static gint __lambda7_ (SnapWidgetsCameraView* self) {
	gint result = 0;
	g_debug ("CameraView.vala:27: Initializing camera view...");
	snap_widgets_camera_view_initialize_view (self);
	result = 0;
	return result;
}


static gpointer ___lambda7__gthread_func (gpointer self) {
	gpointer result;
	result = (gpointer) ((gintptr) __lambda7_ ((SnapWidgetsCameraView*) self));
	g_object_unref (self);
	return result;
}


SnapWidgetsCameraView* snap_widgets_camera_view_construct (GType object_type) {
	SnapWidgetsCameraView * self = NULL;
	GThread* _tmp0_;
	GThread* _tmp1_;
	self = (SnapWidgetsCameraView*) g_object_new (object_type, NULL);
	_tmp0_ = g_thread_new (NULL, ___lambda7__gthread_func, g_object_ref (self));
	_tmp1_ = _tmp0_;
	_g_thread_unref0 (_tmp1_);
	return self;
}


SnapWidgetsCameraView* snap_widgets_camera_view_new (void) {
	return snap_widgets_camera_view_construct (SNAP_WIDGETS_TYPE_CAMERA_VIEW);
}


gboolean snap_widgets_camera_view_take_photo (SnapWidgetsCameraView* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = clutter_gst_camera_is_ready_for_capture ((ClutterGstCamera*) self);
	if (!_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		_tmp2_ = clutter_gst_camera_is_recording_video ((ClutterGstCamera*) self);
		_tmp0_ = _tmp2_;
	}
	if (_tmp0_) {
		g_warning ("CameraView.vala:37: Device isn't ready for taking photos.");
		result = FALSE;
		return result;
	}
	_tmp3_ = snap_utils_get_new_media_filename (SNAP_UTILS_ACTION_TYPE_PHOTO);
	_tmp4_ = _tmp3_;
	clutter_gst_camera_take_photo (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_gst_camera_get_type (), ClutterGstCamera), _tmp4_);
	_g_free0 (_tmp4_);
	result = TRUE;
	return result;
}


gboolean snap_widgets_camera_view_start_recording (SnapWidgetsCameraView* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = clutter_gst_camera_is_ready_for_capture ((ClutterGstCamera*) self);
	if (!_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		_tmp2_ = clutter_gst_camera_is_recording_video ((ClutterGstCamera*) self);
		_tmp0_ = _tmp2_;
	}
	if (_tmp0_) {
		g_warning ("CameraView.vala:49: Device isn't ready for recording videos.");
		result = FALSE;
		return result;
	}
	_tmp3_ = snap_utils_get_new_media_filename (SNAP_UTILS_ACTION_TYPE_VIDEO);
	_tmp4_ = _tmp3_;
	clutter_gst_camera_start_video_recording ((ClutterGstCamera*) self, _tmp4_);
	_g_free0 (_tmp4_);
	result = TRUE;
	return result;
}


void snap_widgets_camera_view_stop_recording (SnapWidgetsCameraView* self) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = clutter_gst_camera_is_recording_video ((ClutterGstCamera*) self);
	if (!_tmp0_) {
		g_warning ("CameraView.vala:61: Cannot stop recording because no record is running" \
".");
		return;
	}
	clutter_gst_camera_stop_video_recording ((ClutterGstCamera*) self);
}


static gboolean ___lambda8_ (SnapWidgetsCameraView* self) {
	gboolean result = FALSE;
	g_signal_emit (self, snap_widgets_camera_view_signals[SNAP_WIDGETS_CAMERA_VIEW_INITIALIZED_SIGNAL], 0);
	result = FALSE;
	return result;
}


static gboolean ____lambda8__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda8_ ((SnapWidgetsCameraView*) self);
	return result;
}


static void snap_widgets_camera_view_initialize_view (SnapWidgetsCameraView* self) {
	GstElement* flip_filter = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	GValue _tmp2_ = {0};
	GstElement* _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gst_element_factory_make ("videoflip", "videoflip");
	if (_tmp0_ != NULL) {
		g_object_ref_sink (_tmp0_);
	}
	flip_filter = _tmp0_;
	_tmp1_ = flip_filter;
	g_value_init (&_tmp2_, G_TYPE_INT);
	g_value_set_int (&_tmp2_, 4);
	g_object_set_property ((GObject*) _tmp1_, "method", &_tmp2_);
	G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
	_tmp3_ = flip_filter;
	clutter_gst_camera_set_filter ((ClutterGstCamera*) self, _tmp3_);
	clutter_gst_player_set_playing ((ClutterGstPlayer*) self, TRUE);
	_tmp4_ = clutter_gst_camera_is_ready_for_capture ((ClutterGstCamera*) self);
	if (_tmp4_) {
		g_debug ("CameraView.vala:77: Camera view initalized.");
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda8__gsource_func, g_object_ref (self), g_object_unref);
	} else {
		g_warning ("CameraView.vala:85: Initializing camera view failed.");
	}
	_g_object_unref0 (flip_filter);
}


static void snap_widgets_camera_view_class_init (SnapWidgetsCameraViewClass * klass) {
	snap_widgets_camera_view_parent_class = g_type_class_peek_parent (klass);
	snap_widgets_camera_view_signals[SNAP_WIDGETS_CAMERA_VIEW_INITIALIZED_SIGNAL] = g_signal_new ("initialized", SNAP_WIDGETS_TYPE_CAMERA_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void snap_widgets_camera_view_instance_init (SnapWidgetsCameraView * self) {
}


GType snap_widgets_camera_view_get_type (void) {
	static volatile gsize snap_widgets_camera_view_type_id__volatile = 0;
	if (g_once_init_enter (&snap_widgets_camera_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SnapWidgetsCameraViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) snap_widgets_camera_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SnapWidgetsCameraView), 0, (GInstanceInitFunc) snap_widgets_camera_view_instance_init, NULL };
		GType snap_widgets_camera_view_type_id;
		snap_widgets_camera_view_type_id = g_type_register_static (clutter_gst_camera_get_type (), "SnapWidgetsCameraView", &g_define_type_info, 0);
		g_once_init_leave (&snap_widgets_camera_view_type_id__volatile, snap_widgets_camera_view_type_id);
	}
	return snap_widgets_camera_view_type_id__volatile;
}



